/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.39 from the
 * contents of Enbugger.xs. Do not edit this file, edit Enbugger.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "Enbugger.xs"
#define PERL_CORE
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"
#include "ppport.h"

/*
 * COPYRIGHT AND LICENCE
 *
 * Copyright (C) 2007,2008 WhitePages.com, Inc. with primary development by
 * Joshua ben Jore.
 *
 * This program is distributed WITHOUT ANY WARRANTY, including but not
 * limited to the implied warranties of merchantability or fitness for
 * a particular purpose.
 *
 * The program is free software.  You may distribute it and/or modify
 * it under the terms of the GNU General Public License as published
 * by the Free Software Foundation (either version 2 or any later
 * version) and the Perl Artistic License as published by O’Reilly
 * Media, Inc.  Please open the files named gpl-2.0.txt and Artistic
 * for a copy of these licenses.
 */


/*
 * Debugging diagnostics.
 */
#define DEBUG (!!EnbuggerDebugMode)
I32 EnbuggerDebugMode = 0;


/*
 * The ENBUGGER_DEBUG environment variable toggles debugging. It is
 * checked once during module loading.
 */
static void
set_debug_from_environment(pTHX)
{
  HV *env_hv;
  SV **svp;

  /* Fetch %ENV. */
  env_hv = get_hv("main::ENV",0);
  if ( ! env_hv ) {
    /* Does this ever happen? */
    Perl_croak(aTHX_ "Couldn't fetch %%ENV hash");
  }

  /* Fetch $ENV{ENBUGGER_DEBUG}. */
  svp = hv_fetch(env_hv,"ENBUGGER_DEBUG",0,0);
  if ( ! ( svp && *svp )) {
    EnbuggerDebugMode = 0;
    return;
  }
  
  EnbuggerDebugMode = SvTRUE( *svp );
}


/*
 * Set a nextstate/dbstate op's op_type and op_ppaddr.
 */
static void
alter_cop( pTHX_ SV *rv, I32 op_type )
{
  SV  *sv;
  COP *cop;


  /*
   * Validate that rv is a B::COP object and it has an IV to vetch.
   */
  if (!( sv_isobject(rv)
	 && sv_isa(rv, "B::COP")
	 && SvOK( sv = SvRV(rv) )
	 && SvIOK(sv) )) {
    if ( DEBUG ) {
      PerlIO_printf(Perl_debug_log, "Enbugger: SvOK(o)=%"UVuf" SvROK(o)=%"UVuf" SvIOK(SvRV(o))=%"UVuf"\n",
          SvOK(sv), SvROK(sv), SvIOK(SvRV(sv)));
    }
    Perl_croak(aTHX_ "Expecting a B::COP object");
  }


  /*
   * Change the type of the COP and the function pointer.
   *
   * TODO: stop hardcoding the values OP_DBSTATE and Perl_pp*. This
   * could be the result of a lookup function. It is allowed 
   */
  cop = INT2PTR( COP*, SvIV(sv) );
  cop->op_type = op_type;
  cop->op_ppaddr =
    op_type == OP_DBSTATE ? Perl_pp_dbstate : Perl_pp_nextstate;

  return;
}






/*
 * All future compilation will result in code without
 * breakpoints. This is typical for code that belongs to debuggers all
 * of which is ordinarily in the DB package.
 *
 * TODO: save off the old values. If the user ever wanted to change
 * these values outside of this module, we'd never know. We should.
 */
static void
compile_with_nextstate() {
  PL_ppaddr[OP_NEXTSTATE]
    = PL_ppaddr[OP_DBSTATE]
    = Perl_pp_nextstate;
}


/*
 * All future compilation will result in code with breakpoints.
 */
static void
compile_with_dbstate() {
  PL_ppaddr[OP_NEXTSTATE]
    = PL_ppaddr[OP_DBSTATE]
    = Perl_pp_dbstate;
}






#line 146 "Enbugger.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 290 "Enbugger.c"

XS_EUPXS(XS_Enbugger_debug); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Enbugger_debug)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "state");
    {
	I32	state = (I32)SvIV(ST(0))
;
#line 156 "Enbugger.xs"
        EnbuggerDebugMode = state;
#line 303 "Enbugger.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Enbugger__nextstate_cop); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Enbugger__nextstate_cop)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "o");
    {
	SV *	o = ST(0)
;
#line 171 "Enbugger.xs"
    alter_cop( aTHX_ o, OP_NEXTSTATE );
#line 320 "Enbugger.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Enbugger__dbstate_cop); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Enbugger__dbstate_cop)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "o");
    {
	SV *	o = ST(0)
;
#line 177 "Enbugger.xs"
    alter_cop( aTHX_ o, OP_DBSTATE );
#line 337 "Enbugger.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Enbugger__compile_with_nextstate); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Enbugger__compile_with_nextstate)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "class");
    {
	SV *	class = ST(0)
;
#line 193 "Enbugger.xs"
    compile_with_nextstate();
#line 354 "Enbugger.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Enbugger__compile_with_dbstate); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Enbugger__compile_with_dbstate)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "class");
    {
	SV *	class = ST(0)
;
#line 199 "Enbugger.xs"
    compile_with_dbstate();
#line 371 "Enbugger.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Enbugger_init_debugger); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Enbugger_init_debugger)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "class");
    {
	SV*	class = ST(0)
;
#line 214 "Enbugger.xs"
    if ( DEBUG ) {
      PerlIO_printf(Perl_debug_log,"Enbugger: Initializing debugger\n");
    }

    init_debugger();
    PL_perldb = PERLDB_ALL;
#line 393 "Enbugger.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Enbugger_set_magic_dbfile); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Enbugger_set_magic_dbfile)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "rv");
    {
	SV *	rv = ST(0)
;
#line 234 "Enbugger.xs"
    HV *hv;
#line 410 "Enbugger.c"
#line 236 "Enbugger.xs"
    assert(SvROK(rv));

    hv = (HV*) SvRV(rv);
    assert(SVt_PVHV == SvTYPE(hv));
    hv_magic(hv, NULL, PERL_MAGIC_dbfile);
#line 417 "Enbugger.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Enbugger__NYTProf_instrument_op); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Enbugger__NYTProf_instrument_op)
{
    dVAR; dXSARGS;
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
    {
#line 296 "Enbugger.xs"
    SV *sv;
    OP *op;
    void *a;
    void *b;
#line 435 "Enbugger.c"
#line 301 "Enbugger.xs"
    if (!( SvOK(ST(0))
           && SvROK(ST(0))
           && SvOK( sv = SvRV(ST(0)) )
           && SvIOK(sv) )) {
      return;
    }

    op = INT2PTR(OP*, SvIV(sv));
    if ( PL_ppaddr[op->op_type] != op->op_ppaddr ) {
      op->op_ppaddr = PL_ppaddr[op->op_type];
    }
#line 448 "Enbugger.c"
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C"
#endif
XS_EXTERNAL(boot_Enbugger); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Enbugger)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if (PERL_REVISION == 5 && PERL_VERSION < 9)
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        newXS_deffile("Enbugger::debug", XS_Enbugger_debug);
        newXS_deffile("Enbugger::_nextstate_cop", XS_Enbugger__nextstate_cop);
        newXS_deffile("Enbugger::_dbstate_cop", XS_Enbugger__dbstate_cop);
        newXS_deffile("Enbugger::_compile_with_nextstate", XS_Enbugger__compile_with_nextstate);
        newXS_deffile("Enbugger::_compile_with_dbstate", XS_Enbugger__compile_with_dbstate);
        newXS_deffile("Enbugger::init_debugger", XS_Enbugger_init_debugger);
        newXS_deffile("Enbugger::set_magic_dbfile", XS_Enbugger_set_magic_dbfile);
        newXS_deffile("Enbugger::NYTProf::instrument_op", XS_Enbugger__NYTProf_instrument_op);

    /* Initialisation Section */

#line 254 "Enbugger.xs"
    set_debug_from_environment(aTHX);

    if ( PL_DBgv ) {
      if ( DEBUG ) {
        PerlIO_printf(Perl_debug_log,"Enbugger: Debugger is already loaded\n" );
      }
    }
    else {
      if ( DEBUG ) {
        PerlIO_printf(Perl_debug_log,"Enbugger: Initializing debugger during Enbugger boot\n");
      }

      /*
       * Copied right out ouf perl.c. I have no idea what this is used
       * for. I've got the idea that maybe something depends on this
       * so I'm including it for now or until I find out that I'm just
       * cargo-culting something inappropriate.
       */
      sv_setpvn(PERL_DEBUG_PAD(0), "", 0);  /* For regex debugging. */
      sv_setpvn(PERL_DEBUG_PAD(1), "", 0);  /* ext/re needs these */
      sv_setpvn(PERL_DEBUG_PAD(2), "", 0);  /* even without DEBUGGING */


      /*
       * It is *mandatory* to initialize the debugger before changing
       * PL_ppaddr. This is to avoid ever compiling code that uses
       * Perl_pp_dbstate without having the required PL_DBsingle, etc
       * variables
       *
       * This will need to be reinitialized again later when an actual
       * debugger is present.
       */
      init_debugger();
    }

#line 528 "Enbugger.c"

    /* End of Initialisation Section */

#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

